NagamochiIbarakiDefaultTraits< GR, CM > Struct Template Reference

- Main Page
- Modules
- Classes
- Namespaces
- Files
- Related Pages

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
List of all members | Public Types | Static Public Member Functions
NagamochiIbarakiDefaultTraits< GR, CM > Struct Template Reference

## Detailed Description

### template<typename GR, typename CM>
struct lemon::NagamochiIbarakiDefaultTraits< GR, CM >

Default traits class for NagamochiIbaraki class.

Parameters

  GR | The undirected graph type.
  CM | Type of capacity map.

`#include <lemon/nagamochi_ibaraki.h>`

## Public Types
typedef CM::Value | Value
| The type of the capacity map.
typedef GR | Graph
| The undirected graph type the algorithm runs on.
typedef CM | CapacityMap
| The type of the map that stores the edge capacities. More...
typedef Graph::template NodeMap< int > | HeapCrossRef
| The cross reference type used by heap. More...
typedef BinHeap< Value, HeapCrossRef, std::greater < Value > > | Heap
| The heap type used by NagamochiIbaraki algorithm. More...

## Static Public Member Functions
static CapacityMap * | createCapacityMap (const Graph &graph)
| Instantiates a CapacityMap. More...
static HeapCrossRef * | createHeapCrossRef (const Graph &g)
| Instantiates a HeapCrossRef. More...
static Heap * | createHeap (HeapCrossRef &r)
| Instantiates a Heap. More...

## Member Typedef Documentation

typedef CM CapacityMap

The type of the map that stores the edge capacities. It must meet the ReadMap concept.

typedef Graph::template NodeMap<int> HeapCrossRef

The cross reference type used by heap. Usually `Graph::NodeMap<int>`.

typedef BinHeap<Value, HeapCrossRef, std::greater<Value> > Heap

The heap type used by NagamochiIbaraki algorithm. It has to maximize the priorities.

See Also
  BinHeap
  NagamochiIbaraki

## Member Function Documentation

static CapacityMap* createCapacityMap | ( | const Graph & | graph | ) |
| inlinestatic

This function instantiates a CapacityMap.

static HeapCrossRef* createHeapCrossRef | ( | const Graph & | g | ) |
| inlinestatic

This function instantiates a HeapCrossRef.

Parameters

  g | is the graph, to which we would like to define the HeapCrossRef.

static Heap* createHeap | ( | HeapCrossRef & | r | ) |
| inlinestatic

This function instantiates a Heap.

Parameters

  r | is the cross reference of the heap.